package com.vdocipher.flutter.vdoplayer;

import androidx.annotation.Nullable;

import com.vdocipher.aegis.media.ErrorDescription;
import com.vdocipher.aegis.media.MediaInfo;
import com.vdocipher.aegis.player.VdoPlayer;

import java.util.HashMap;

public class MessageUtils {
    public static HashMap<String, Object> loadResultMap(@Nullable MediaInfo mediaInfo) {
        HashMap<String, Object> loadResultMap = new HashMap<>();
        if (mediaInfo == null) {
            loadResultMap.put("didLoad", false);
        } else {
            loadResultMap.put("didLoad", true);
            loadResultMap.put("mediaInfo", mediaInfoMap(mediaInfo));
            loadResultMap.put("playWhenReady", true);
        }
        return loadResultMap;
    }

    public static HashMap<String, Object> mediaInfoMap(MediaInfo mediaInfo) {
        HashMap<String, Object> mediaInfoMap = new HashMap<>();
        mediaInfoMap.put("mediaId", mediaInfo.mediaId);
        mediaInfoMap.put("type", mediaInfo.type);
        mediaInfoMap.put("title", mediaInfo.title);
        mediaInfoMap.put("description", mediaInfo.description);
        mediaInfoMap.put("duration", mediaInfo.duration);
        return mediaInfoMap;
    }

    public static HashMap<String, Object> errorInfoMap(ErrorDescription error) {
        HashMap<String, Object> errorInfoMap = new HashMap<>();
        errorInfoMap.put("errorCode", error.errorCode);
        errorInfoMap.put("errorMsg", error.errorMsg);
        errorInfoMap.put("httpStatusCode", error.httpStatusCode);
        return errorInfoMap;
    }

    public static String playerStateName(int vdoPlayerState) {
        switch (vdoPlayerState) {
            case VdoPlayer.STATE_IDLE:
                return "idle";
            case VdoPlayer.STATE_BUFFERING:
                return "buffering";
            case VdoPlayer.STATE_READY:
                return "ready";
            case VdoPlayer.STATE_ENDED:
                return "ended";
            default:
                return "unknown";
        }
    }
}
