package com.vdocipher.flutter.vdoplayer;

import androidx.annotation.NonNull;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;

/** VdocipherFlutterPlugin */
public class VdocipherFlutterPlugin implements FlutterPlugin, MethodCallHandler {

  private static final String VDO_PLAYER_VIEW_TYPE = "com.vdocipher.flutter/vdoplayerview";

  /// The MethodChannel that will the communication between Flutter and native Android
  ///
  /// This local reference serves to register the plugin with the Flutter Engine and unregister it
  /// when the Flutter Engine is detached from the Activity
  private MethodChannel channel;

  @Override
  public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
    channel = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), "com.vdocipher.flutter");
    channel.setMethodCallHandler(this);

    flutterPluginBinding
            .getPlatformViewRegistry()
            .registerViewFactory(VDO_PLAYER_VIEW_TYPE,
                    new VdoPlayerPlatformViewFactory(flutterPluginBinding.getBinaryMessenger(), null));
  }

  @Override
  public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {
    if (call.method.equals("getNativeAndroidLibraryVersion")) {
      result.success(com.vdocipher.aegis.BuildConfig.VERSION_NAME);
    } else {
      result.notImplemented();
    }
  }

  @Override
  public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
    channel.setMethodCallHandler(null);
  }
}
