import 'package:flutter/material.dart';
import 'embed_info_options.dart';

/// Initial parameters specifying the video to load and playback preferences.
class EmbedInfo {
  final bool offline;
  final String otp;
  final String playbackInfo;
  final String mediaId;
  final EmbedInfoOptions embedInfoOptions;

  const EmbedInfo.streaming({
    @required this.otp,
    @required this.playbackInfo,
    this.embedInfoOptions,
  }) : offline = false, mediaId = null,
        assert(otp != null), assert(playbackInfo != null);

  const EmbedInfo.offline({
    @required this.mediaId,
    this.embedInfoOptions
  }) : offline = true, otp = null, playbackInfo = null,
        assert(mediaId != null);

  Map<String, Object> toMap() {
    return {
      'offline': offline,
      'otp': otp,
      'playbackInfo': playbackInfo,
      'mediaId': mediaId,
      'embedInfoOptions': embedInfoOptions == null ? null : embedInfoOptions.toMap()
    };
  }
}